<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__mcwdt" kind="group">
    <compoundname>group_mcwdt</compoundname>
    <title>MCWDT        (Multi-Counter Watchdog)</title>
    <innergroup refid="group__group__mcwdt__macros">Macros</innergroup>
    <innergroup refid="group__group__mcwdt__functions">Functions</innergroup>
    <innergroup refid="group__group__mcwdt__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__mcwdt__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>A MCWDT has two 16-bit counters and one 32-bit counter. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_mcwdt.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>You can use this driver to create a free-running timer or generate periodic interrupts. The driver also includes support for the watchdog function to recover from CPU or firmware failures.</para><para>There are two primary use cases for MCWDT: generating periodic CPU interrupts; and implementing a free-running timer. Both have many applications in embedded systems:<itemizedlist>
<listitem><para>Measuring time between events</para></listitem><listitem><para>Generating periodic events</para></listitem><listitem><para>Synchronizing actions</para></listitem><listitem><para>Real-time clocking</para></listitem><listitem><para>Polling</para></listitem></itemizedlist>
</para><para>An additional use case is to implement a watchdog used for recovering from a CPU or firmware failure.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>Each MCWDT may be configured for a particular product. One MCWDT block can be associated with only one CPU during runtime. A single MCWDT is not intended to be used by multiple CPUs simultaneously. Each block contains three sub-counters, each of which can be configured for various system utility functions - free running counter, periodic interrupts, watchdog reset, or three interrupts followed by a watchdog reset. All counters are clocked by either LFCLK (nominal 32 kHz) or by a cascaded counter. A simplified diagram of the MCWDT hardware is shown below: <image name="mcwdt.png" type="html" /></para><para>
 The frequency of the periodic interrupts can be configured using the Match value with combining Clear on match option, which can be set individually for each counter using <ref kindref="member" refid="group__group__mcwdt__functions_1ga77bb788adb7fac2042772b00a61f95cb">Cy_MCWDT_SetClearOnMatch()</ref>. When the Clear on match option is not set, the periodic interrupts of the C0 and C1 16-bit sub-counters occur after 65535 counts and the match value defines the shift between interrupts (see the figure below). The enabled Clear on match option resets the counter when the interrupt occurs. <image name="mcwdt_counters.png" type="html" /></para><para>
 32-bit sub-counter C2 does not have Clear on match option. The interrupt of counter C2 occurs when the counts equal 2<superscript>Toggle bit</superscript> value. <image name="mcwdt_subcounters.png" type="html" /></para><para>
 To set up an MCWDT, provide the configuration parameters in the <ref kindref="compound" refid="structcy__stc__mcwdt__config__t">cy_stc_mcwdt_config_t</ref> structure. Then call <ref kindref="member" refid="group__group__mcwdt__functions_1gab8bd6fb7ec48ef294287c01e179c41df">Cy_MCWDT_Init()</ref> to initialize the driver. Call <ref kindref="member" refid="group__group__mcwdt__functions_1ga90f8d4636fc67fc8abe3bfd87ab521ac">Cy_MCWDT_Enable()</ref> to enable all specified counters.</para><para>You can also set the mode of operation for any counter. If you choose interrupt mode, use <ref kindref="member" refid="group__group__mcwdt__functions_1gaeaa26b488af90a877760cffc61ad08e3">Cy_MCWDT_SetInterruptMask()</ref> with the parameter for the masks described in Macro Section. All counter interrupts are OR'd together to from a single combined MCWDT interrupt. Additionally, enable the Global interrupts and initialize the referenced interrupt by setting the priority and the interrupt vector using <ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init()</ref> of the sysint driver.</para><para>The values of the MCWDT counters can be monitored using <ref kindref="member" refid="group__group__mcwdt__functions_1ga82cd9aad79c9faf18b7a5ada22c3f7d3">Cy_MCWDT_GetCount()</ref>.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;In addition to the MCWDTs, each device has a separate watchdog timer (WDT) that can also be used to generate a watchdog reset or periodic interrupts. For more information on the WDT, see the appropriate section of the PDL.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">More Information</heading></para>
<para>For more information on the MCWDT peripheral, refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The mcwdt driver does not have any specific deviations.</para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;In version 1.20 the &lt;a href="group__group__mcwdt__functions.html#group__group__mcwdt__functions_1ga2c7f8cc4f0897618bb6c4b3389357086"&gt;Cy_MCWDT_GetCountCascaded()&lt;/a&gt; function returned the wrong value when counter#1 overflowed. This bug is corrected in version 1.30.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixes.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated description of the &lt;a href="structcy__stc__mcwdt__config__t.html#"&gt;cy_stc_mcwdt_config_t&lt;/a&gt; structure type &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added input parameter validation to the API functions.&lt;br /&gt; Added API function GetCountCascaded() &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>